#ifndef SpielStatistik_H
#define SpielStatistik_H

#include <SpielStatistikV.h>
#include "SpielStatistikDaten.h"
#include "Chat/StatistikChat.h"
#include "Runde/StatistikRunde.h"
#include "Tabelle/StatistikTabelle.h"

class SpielStatistik : public SpielStatistikV
{
private:
	UIInit uiFactory;
	void(*addNachrichtF)(void*, Text*, Text*, Text*, Text*);
	void(*addChatF)(void*, int);
	void(*addFreundF)(void*, int);
	void(*accountAnsehenF)(void*, int);
	bool(*istFreundF)(void*, int);
	void* nachrichtParam;
	BilderV* bilder;
	KSGClient::InformationServerClient* infoc;
	KSGClient::SpielServerClient* spielc;
	CRITICAL_SECTION cs;
	Array< SSDGesamtSpieler* >* gss;
	Array< SSDGesamtTeam* >* gts;
	Array< SSDRunde* >* rs;
	StatistikChat* chat;
	StatistikRunde* runde;
	StatistikTabelle* tabelle;
	int accountId;
	bool rend;
	int status;

public:
	// Konstruktor
	SpielStatistik();
	// Destruktor
	~SpielStatistik();
	// nicht constant
	void lock();
	void unlock();
	virtual void bereit() override;
	virtual void setBilder(BilderV* b) override;
	virtual void setAccountId(int id) override;
	virtual void setRckrufFunktionen(void(*addNachrichtF)(void*, Text*, Text*, Text*, Text*),
		void(*addChatF)(void*, int), void(*addFreundF)(void*, int),
		void(*accountAnsehenF)(void*, int), bool(*istFreundF)(void*, int), void* nachrichtParam) override;
	virtual void setUIFactory(UIInit& factory) override;
	virtual void setKlients(KSGClient::InformationServerClient* infoc, KSGClient::SpielServerClient* spielc) override;
	virtual void nachricht(int ln, const char* bytes) override;
	virtual void doPublicMausEreignis(MausEreignis& me) override;
	virtual void doTastaturEreignis(TastaturEreignis& te) override;
	virtual bool tick(double zeit) override;
	virtual void render(Bild& zRObj) override;
	virtual void verlassen() override;
	// constant
	virtual int getStatus() const override; // 0 = laden, 1 = luft, 2 = fortsetzen
};

#endif